

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

Represents transfering progress.
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.Ggit.Structs.TransferProgress
    ( 

-- * Exported types
    TransferProgress(..)                    ,
    noTransferProgress                      ,


 -- * Methods
-- ** copy #method:copy#

#if ENABLE_OVERLOADING
    TransferProgressCopyMethodInfo          ,
#endif
    transferProgressCopy                    ,


-- ** free #method:free#

#if ENABLE_OVERLOADING
    TransferProgressFreeMethodInfo          ,
#endif
    transferProgressFree                    ,


-- ** getIndexedObjects #method:getIndexedObjects#

#if ENABLE_OVERLOADING
    TransferProgressGetIndexedObjectsMethodInfo,
#endif
    transferProgressGetIndexedObjects       ,


-- ** getReceivedBytes #method:getReceivedBytes#

#if ENABLE_OVERLOADING
    TransferProgressGetReceivedBytesMethodInfo,
#endif
    transferProgressGetReceivedBytes        ,


-- ** getReceivedObjects #method:getReceivedObjects#

#if ENABLE_OVERLOADING
    TransferProgressGetReceivedObjectsMethodInfo,
#endif
    transferProgressGetReceivedObjects      ,


-- ** getTotalObjects #method:getTotalObjects#

#if ENABLE_OVERLOADING
    TransferProgressGetTotalObjectsMethodInfo,
#endif
    transferProgressGetTotalObjects         ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL


-- | Memory-managed wrapper type.
newtype TransferProgress = TransferProgress (ManagedPtr TransferProgress)
foreign import ccall "ggit_transfer_progress_get_type" c_ggit_transfer_progress_get_type :: 
    IO GType

instance BoxedObject TransferProgress where
    boxedType _ = c_ggit_transfer_progress_get_type

-- | A convenience alias for `Nothing` :: `Maybe` `TransferProgress`.
noTransferProgress :: Maybe TransferProgress
noTransferProgress = Nothing


#if ENABLE_OVERLOADING
instance O.HasAttributeList TransferProgress
type instance O.AttributeList TransferProgress = TransferProgressAttributeList
type TransferProgressAttributeList = ('[ ] :: [(Symbol, *)])
#endif

-- method TransferProgress::copy
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "progress", argType = TInterface (Name {namespace = "Ggit", name = "TransferProgress"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GgitTransferProgress.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "Ggit", name = "TransferProgress"}))
-- throws : False
-- Skip return : False

foreign import ccall "ggit_transfer_progress_copy" ggit_transfer_progress_copy :: 
    Ptr TransferProgress ->                 -- progress : TInterface (Name {namespace = "Ggit", name = "TransferProgress"})
    IO (Ptr TransferProgress)

{- |
Copies /@progress@/ into a newly allocated 'GI.Ggit.Structs.TransferProgress.TransferProgress'.
-}
transferProgressCopy ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    TransferProgress
    {- ^ /@progress@/: a 'GI.Ggit.Structs.TransferProgress.TransferProgress'. -}
    -> m (Maybe TransferProgress)
    {- ^ __Returns:__ a newly allocated 'GI.Ggit.Structs.TransferProgress.TransferProgress' or 'Nothing'. -}
transferProgressCopy progress = liftIO $ do
    progress' <- unsafeManagedPtrGetPtr progress
    result <- ggit_transfer_progress_copy progress'
    maybeResult <- convertIfNonNull result $ \result' -> do
        result'' <- (wrapBoxed TransferProgress) result'
        return result''
    touchManagedPtr progress
    return maybeResult

#if ENABLE_OVERLOADING
data TransferProgressCopyMethodInfo
instance (signature ~ (m (Maybe TransferProgress)), MonadIO m) => O.MethodInfo TransferProgressCopyMethodInfo TransferProgress signature where
    overloadedMethod _ = transferProgressCopy

#endif

-- method TransferProgress::free
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "progress", argType = TInterface (Name {namespace = "Ggit", name = "TransferProgress"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GgitTransferProgress.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "ggit_transfer_progress_free" ggit_transfer_progress_free :: 
    Ptr TransferProgress ->                 -- progress : TInterface (Name {namespace = "Ggit", name = "TransferProgress"})
    IO ()

{- |
Frees /@progress@/.
-}
transferProgressFree ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    TransferProgress
    {- ^ /@progress@/: a 'GI.Ggit.Structs.TransferProgress.TransferProgress'. -}
    -> m ()
transferProgressFree progress = liftIO $ do
    progress' <- unsafeManagedPtrGetPtr progress
    ggit_transfer_progress_free progress'
    touchManagedPtr progress
    return ()

#if ENABLE_OVERLOADING
data TransferProgressFreeMethodInfo
instance (signature ~ (m ()), MonadIO m) => O.MethodInfo TransferProgressFreeMethodInfo TransferProgress signature where
    overloadedMethod _ = transferProgressFree

#endif

-- method TransferProgress::get_indexed_objects
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "progress", argType = TInterface (Name {namespace = "Ggit", name = "TransferProgress"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GgitTransferProgress.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt)
-- throws : False
-- Skip return : False

foreign import ccall "ggit_transfer_progress_get_indexed_objects" ggit_transfer_progress_get_indexed_objects :: 
    Ptr TransferProgress ->                 -- progress : TInterface (Name {namespace = "Ggit", name = "TransferProgress"})
    IO Word32

{- |
Gets the indexed objects of the transfer.
-}
transferProgressGetIndexedObjects ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    TransferProgress
    {- ^ /@progress@/: a 'GI.Ggit.Structs.TransferProgress.TransferProgress'. -}
    -> m Word32
    {- ^ __Returns:__ the indexed objects of the transfer. -}
transferProgressGetIndexedObjects progress = liftIO $ do
    progress' <- unsafeManagedPtrGetPtr progress
    result <- ggit_transfer_progress_get_indexed_objects progress'
    touchManagedPtr progress
    return result

#if ENABLE_OVERLOADING
data TransferProgressGetIndexedObjectsMethodInfo
instance (signature ~ (m Word32), MonadIO m) => O.MethodInfo TransferProgressGetIndexedObjectsMethodInfo TransferProgress signature where
    overloadedMethod _ = transferProgressGetIndexedObjects

#endif

-- method TransferProgress::get_received_bytes
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "progress", argType = TInterface (Name {namespace = "Ggit", name = "TransferProgress"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GgitTransferProgress.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt64)
-- throws : False
-- Skip return : False

foreign import ccall "ggit_transfer_progress_get_received_bytes" ggit_transfer_progress_get_received_bytes :: 
    Ptr TransferProgress ->                 -- progress : TInterface (Name {namespace = "Ggit", name = "TransferProgress"})
    IO Word64

{- |
Gets the received bytes of the transfer.
-}
transferProgressGetReceivedBytes ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    TransferProgress
    {- ^ /@progress@/: a 'GI.Ggit.Structs.TransferProgress.TransferProgress'. -}
    -> m Word64
    {- ^ __Returns:__ the received bytes of the transfer. -}
transferProgressGetReceivedBytes progress = liftIO $ do
    progress' <- unsafeManagedPtrGetPtr progress
    result <- ggit_transfer_progress_get_received_bytes progress'
    touchManagedPtr progress
    return result

#if ENABLE_OVERLOADING
data TransferProgressGetReceivedBytesMethodInfo
instance (signature ~ (m Word64), MonadIO m) => O.MethodInfo TransferProgressGetReceivedBytesMethodInfo TransferProgress signature where
    overloadedMethod _ = transferProgressGetReceivedBytes

#endif

-- method TransferProgress::get_received_objects
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "progress", argType = TInterface (Name {namespace = "Ggit", name = "TransferProgress"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GgitTransferProgress.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt)
-- throws : False
-- Skip return : False

foreign import ccall "ggit_transfer_progress_get_received_objects" ggit_transfer_progress_get_received_objects :: 
    Ptr TransferProgress ->                 -- progress : TInterface (Name {namespace = "Ggit", name = "TransferProgress"})
    IO Word32

{- |
Gets the received objects of the transfer.
-}
transferProgressGetReceivedObjects ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    TransferProgress
    {- ^ /@progress@/: a 'GI.Ggit.Structs.TransferProgress.TransferProgress'. -}
    -> m Word32
    {- ^ __Returns:__ the received objects of the transfer. -}
transferProgressGetReceivedObjects progress = liftIO $ do
    progress' <- unsafeManagedPtrGetPtr progress
    result <- ggit_transfer_progress_get_received_objects progress'
    touchManagedPtr progress
    return result

#if ENABLE_OVERLOADING
data TransferProgressGetReceivedObjectsMethodInfo
instance (signature ~ (m Word32), MonadIO m) => O.MethodInfo TransferProgressGetReceivedObjectsMethodInfo TransferProgress signature where
    overloadedMethod _ = transferProgressGetReceivedObjects

#endif

-- method TransferProgress::get_total_objects
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "progress", argType = TInterface (Name {namespace = "Ggit", name = "TransferProgress"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GgitTransferProgress.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TUInt)
-- throws : False
-- Skip return : False

foreign import ccall "ggit_transfer_progress_get_total_objects" ggit_transfer_progress_get_total_objects :: 
    Ptr TransferProgress ->                 -- progress : TInterface (Name {namespace = "Ggit", name = "TransferProgress"})
    IO Word32

{- |
Gets the total objects of the transfer.
-}
transferProgressGetTotalObjects ::
    (B.CallStack.HasCallStack, MonadIO m) =>
    TransferProgress
    {- ^ /@progress@/: a 'GI.Ggit.Structs.TransferProgress.TransferProgress'. -}
    -> m Word32
    {- ^ __Returns:__ the total objects of the transfer. -}
transferProgressGetTotalObjects progress = liftIO $ do
    progress' <- unsafeManagedPtrGetPtr progress
    result <- ggit_transfer_progress_get_total_objects progress'
    touchManagedPtr progress
    return result

#if ENABLE_OVERLOADING
data TransferProgressGetTotalObjectsMethodInfo
instance (signature ~ (m Word32), MonadIO m) => O.MethodInfo TransferProgressGetTotalObjectsMethodInfo TransferProgress signature where
    overloadedMethod _ = transferProgressGetTotalObjects

#endif

#if ENABLE_OVERLOADING
type family ResolveTransferProgressMethod (t :: Symbol) (o :: *) :: * where
    ResolveTransferProgressMethod "copy" o = TransferProgressCopyMethodInfo
    ResolveTransferProgressMethod "free" o = TransferProgressFreeMethodInfo
    ResolveTransferProgressMethod "getIndexedObjects" o = TransferProgressGetIndexedObjectsMethodInfo
    ResolveTransferProgressMethod "getReceivedBytes" o = TransferProgressGetReceivedBytesMethodInfo
    ResolveTransferProgressMethod "getReceivedObjects" o = TransferProgressGetReceivedObjectsMethodInfo
    ResolveTransferProgressMethod "getTotalObjects" o = TransferProgressGetTotalObjectsMethodInfo
    ResolveTransferProgressMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveTransferProgressMethod t TransferProgress, O.MethodInfo info TransferProgress p) => OL.IsLabel t (TransferProgress -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif


